/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2012
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2012
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file I_P2PMatchListener.h
 *       @see I_P2PMatchListener.
 *
 *  @date 10.08.2011
 *  @author Tobias Hilbrich, Mathias Korepkat, Joachim Protze
 */

#include "BaseIds.h"
#include "MustEnums.h"
#include "MustTypes.h"

#ifndef I_P2PMATCHLISTENER_H
#define I_P2PMATCHLISTENER_H

namespace must
{
    /**
     * Interface to be implemented by listeners on P2P matches.
     */
    class I_P2PMatchListener
    {
    public:
        /**
         * Called when a new P2P match occurs.
         */
        virtual void newMatch (
                int sendRankWorld,
                int receiveRankWorld,
                bool sendHasRequest,
                MustRequestType sendRequest,
                bool receiveHasRequest,
                MustRequestType receiveRequest,
                must::MustSendMode sendMode) = 0;

    };/*class I_P2PMatchListener*/
} /*namespace must*/

#endif /*I_P2PMATCHLISTENER_H*/
