/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2010-2012
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2010-2012
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file ParallelIdImpl.cpp
 *       Implementation for the parallel id analysis interface.
 *
 *  @date 07.01.2010
 *  @author Tobias Hilbrich
 */

#include "GtiMacros.h"

#include "ParallelIdImpl.h"

using namespace must;

mGET_INSTANCE_FUNCTION(ParallelIdImpl);
mFREE_INSTANCE_FUNCTION(ParallelIdImpl);
mPNMPI_REGISTRATIONPOINT_FUNCTION(ParallelIdImpl);

//=============================
// Constructor
//=============================
ParallelIdImpl::ParallelIdImpl (const char* instanceName)
    : gti::ModuleBase<ParallelIdImpl, I_ParallelIdAnalysis> (instanceName)
{
    //create sub modules
    std::vector<I_Module*> subModInstances;
    subModInstances = createSubModuleInstances ();
    //No sub modules needed ...
}

//=============================
// getInfoForId
//=============================
ParallelInfo ParallelIdImpl::getInfoForId (MustParallelId id)
{
	/*
	 * Will be enhanced along the road.
	 */

	ParallelInfo ret;
	ret.rank = id;
	return ret;
}


//=============================
// toString
//=============================
std::string ParallelIdImpl::toString (MustParallelId id)
{
	ParallelInfo info = getInfoForId (id);
	std::string ret = "";

	char temp[128];
	sprintf (temp, "%d", info.rank);
	ret += (std::string)("rank ") + temp;

	return ret;
}

/*EOF*/
