/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2012
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2012
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file datatypetest.h
 * Helper functions, headers
 *
 * @author Joachim Protze
 */

#ifndef DATATYPE_TEST_H
#define DATATYPE_TEST_H

#include "stdlib.h"
#include "stdio.h"
#include "mpi.h"
#include "mustConfig.h"

// #define datatypeTest advancedTest
#define datatypeTest noopTest

void printIntMap(MPI_Datatype type);

void printTypeAttributes(MPI_Datatype type);

void advancedTest(MPI_Datatype type);
void noopTest(MPI_Datatype type);

int mpiResizedByStruct(MPI_Datatype oldtype, MPI_Aint lb, MPI_Aint extent, MPI_Datatype* newtype);

int mpiResizedByStructLimits(MPI_Datatype oldtype, MPI_Aint lb, MPI_Aint extent, MPI_Datatype* newtype);

int mpiResizedByHindexed(MPI_Datatype oldtype, MPI_Aint lb, MPI_Aint extent, MPI_Datatype* newtype);

#endif /*DATATYPE_TEST_H*/
